# Core_Digital_Inspection.tcl
proc run_test {} {
global %%Waiting
set dg_status [click-status]
InsertLog "Step through the Digital Inspection signals "

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}
# zero the offsets 
setup_offset
# enable the data buffers and select low gain
Set_Register 7 0x0300
# Enable the Inspection lines
Set_Register 4 7
for { set i 1 } { $i < 3 } { incr i 1 } {
	Set_Register 8 $i
	Set_Register 2 $i
	Set_Register 3 $i

	WaitForUser "Channel $i OK ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}
}

InsertLog "Script completed "


}
proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
