# Core_bits.tcl
proc run_test {} {
global %%Waiting
set dg_status [click-status]
set LED_names { AT10_D(1) AT10_D(2) AT10_D(3) AT10_D(4) Mode Gain_clock Gain_data Gain_Sel PS_EN Pulse }

InsertLog "Check isolator paths"

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}

set i 0

foreach val { 1 2 4 8 128 16 32 64 256 512 } {
	set Lnam [ lindex $LED_names $i ]
	incr i
	Set_Register 14 $val 
	WaitForUser "LED $Lnam On ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}

}

if { $rtnd == -2 } {
	InsertLog "Ended "
	return
}
Set_Register 14 0
InsertLog "Also the SHDN_C control off"

set control [ Get_Register 0 ]
set a [ expr $control & 0xffef ]
Set_Register 0 $a
	WaitForUser "LED SHDN_C off ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}
Set_Register 0 $control 

InsertLog "Script completed "
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
