#Core_init.tcl
proc run_test {} {

# set the external clock option
if { [SelectFpga "Core: Main Board"] == -1 } then { 
	WaitForUser "Can't connect to Main board" 
	return
}
Set_Register 40 0 
InsertLog "External Clock selected"

# enable the Core Laser and push it's DCMs to lock.

InsertLog "Initialise Core"
set dg_status [click-status]

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}


# set the basics - inpsection and main enables
Set_Register 2 1
Set_Register 3 1
Set_Register 8 1
Set_Register 4 7

Set_Register 7 0x300
Set_Register 0 0x175
Set_Register 0 0x75
 set val [Get_Register 1 ]
 if { $val == 0xd201 } then {
	InsertLog "Core status  fault : ([format "0x%x" $val])"
	WaitForUser "Is the cable connected ?"
	set rtnd %%Waiting
	if { $rtnd == -2 } then {
		return
	}
	InsertLog "Resetting the DCMs "
	Set_Register 0 0x175
	Set_Register 0 0x75
 	set val [Get_Register 1 ]
	 if { $val == 0xd201 } then {
		InsertLog "Core status  fault : ([format "0x%x" $val])"
		InsertLog " All DCMs are not operational "

	}
}
setup_offset
Set_Register 0x13 0x7c00
Set_Register 0x13 0
InsertLog "Core initialised : Laser enabled : External Clock : DCMs OK"
InsertLog "Core initialised : Insp => Ch1 : Ch1 Rocket enabled => Data "

}
# processes to help for later work
proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
}
# finally do the work ;-)
run_test

# WaitForUser "Data enabled, is the  ?"
#    syntax  Set_Register address_offset  value
# WaitForUser "Data synchronised ?"
# InsertLog "wait returned [set %%Waiting]"
# values of %%Waiting are  -1 (continue)   and   -2  (Abort)
# InsertLog "register at offset 2 has value [Get_Register 2]"
#    syntax  Get_Register address_offset
#    returns value

# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 
