# Core_init_Transmit_1_by_1.tcl

proc run_test {} {
global %%Waiting
InsertLog "Initialise Core and step through the Lasers "

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}
# set the basics - inpsection and main enables
	setup_offset
# enable the laser
	Set_Register 0 0x75
	Set_Register 4 7
	Set_Register 7 0x300

# check the status register for DCM locked.
 set val [Get_Register 1 ]
 if { $val != 0xe001 } {
	InsertLog "Core status  fault : ([format "0x%x" $val])"
	WaitForUser "Continue  ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}
}

# channel by channel set inspection lines 1 and 2 and analog to ch, and transmit data enabled
foreach val { 1 2 } {
	Set_Register 2 $val
	Set_Register 3 $val
	Set_Register 8 $val
	set ch_rkt [expr ( $val << 4 ) + 3 ]
	Set_Register $ch_rkt 0x7c00
	InsertLog "Core $val : Transmitting sync pattern"

	WaitForUser "Check Received data is FC00 and status is locked. OK?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		break
	}

	Set_Register $ch_rkt 0
	InsertLog "Core $val : Transmitting data"
	WaitForUser "Check Outputs from AI & V2P DAC. OK?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		break
	}
	Set_Register $ch_rkt 0x7c00
}
if { $rtnd == -2 } {
	InsertLog "Ended "
	return
}
InsertLog "Script completed "
}

proc setup_offset {} {
	Set_Register 0x80 0
	Set_Register 0x81 0
	Set_Register 0x82 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
