# Core_initial_test.tcl
proc run_test {} {
global %%Waiting

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}


# set the basics - inpsection and main enables
set rtnd [Reg-test 2]
if { $rtnd == -2 } {
	InsertLog "Register test failed - check comms and rerun "
	return
}
# turn the LED off and 0n again
Set_Register 0 8
WaitForUser "Check LED 7 is Off - OK ?"
set rtnd [set %%Waiting ]
if { $rtnd == -2 } {
	return
}
Set_Register 0 0
WaitForUser "Check LED 7 is On - OK ?"
set rtnd [ set %%Waiting ]
if { $rtnd == -2 } {
	return
}

InsertLog "Comms check complete "

}
proc Reg-test { addr } {
	InsertLog " Testing register $addr "
	foreach value { 0 1 4 8 16 32 64 128 256 512 1024 2048 4096 8192 16384 32768 } {
		Set_Register $addr $value
		set val  [ Get_Register $addr ] 
		if { $value != $val } {
			InsertLog " Should be [format "0x%x" $value] but read back [format "0x%x" $val]"
			WaitForUser "Continue ?"
			set rtnd [set %%Waiting ]
			if { $rtnd == -2 } {
				return -2
			}
		}
	}
}
# processes to help for later work
proc setup_offset {} {
	Set_Register 0x80 0
	Set_Register 0x81 0
	Set_Register 0x82 0
}
# finally do the work ;-)
run_test

# WaitForUser "Data enabled, is the  ?"
#    syntax  Set_Register address_offset  value
# WaitForUser "Data synchronised ?"
# InsertLog "wait returned [set %%Waiting]"
# values of %%Waiting are  -1 (continue)   and   -2  (Abort)
# InsertLog "register at offset 2 has value [Get_Register 2]"
#    syntax  Get_Register address_offset
#    returns value

# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 
