# Core_ram_test.tcl

proc run_test {} {
global %%Waiting
set dg_status [click-status]
InsertLog "Run the Ram test"

if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
	WaitForUser "No Core card available !" 
	return
}

set val 1
Set_Register 0 0x75
Set_Register 0 0x2075
InsertLog "Ram test started"
set rtnd 0
while { $val == 1 }  {
	set status [ Get_Register 1 ]
	set ram_result [ expr ( $status >> 4 ) & 7 ]
 	if { $ram_result != 1 } {
		InsertLog "Core status : RAM test fault $ram_result: ([format "0x%x" $status])"
		WaitForUser "Continue  ?"
		set rtnd [ set %%Waiting ]
		if { $rtnd == -2 } {
			set val 0
			break
		}
	} else {
		set val 0
	}
}
if { $rtnd == -2 } {
	InsertLog "Ended "
	return
}
if { $ram_result == 1 } {
	InsertLog " RAM test passed "
} else {
	InsertLog " RAM test failed "
}
Set_Register 0 0x75
InsertLog "Script completed "
}

proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0

}

run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
