# run_digitiser_all_adc.tcl
set my_Debug 0 
set do_pause 0
proc run_test {} {
	global %%Waiting
	SelectDigitizer 0  
# set the external clock option
	if { [SelectFpga "Core: Main Board"] == -1 } then { 
		WaitForUser "Can't connect to Main board" 
		return
	}
	set rtnd 0
	Set_Register 40 0 
	InsertLog "External Clock selected"

# enable the Core Laser and push it's DCMs to lock.

	InsertLog "Initialise Core clock and sync"
	set dg_status [click-status]

	if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
		WaitForUser "No Core card available !" 
		return
	}

# set the sync pulse to be correctly transmitted

	Set_Register 11 1
	
# set the basics - inpsection and main enables
	Set_Register 2 1
	Set_Register 3 1
	Set_Register 8 1
	Set_Register 4 7

	Set_Register 7 0x300
	Set_Register 0 0x175
	Set_Register 0 0x75
 	set val [Get_Register 1 ]
	set val [ expr $val & 0xfffD ]
 	if { $val != 0xf205 } then {
		InsertLog "Core status  fault : ([format "0x%x" $val])"
		WaitForUser "Is the cable connected ?"
		set rtnd %%Waiting
		if { $rtnd == -2 } then {
			return
		}
		InsertLog "Resetting the DCMs "
		Set_Register 0 0x175
		Set_Register 0 0x75
 		set val [Get_Register 1 ]
		set val [ expr $val & 0xfffD ]
		if { $val != 0xf205 } then {
			InsertLog "Core status  fault : ([format "0x%x" $val])"
			InsertLog " All DCMs are not operational "
			WaitForUser "Is the cable connected ?"
			set rtnd %%Waiting
			if { $rtnd == -2 } then {
				return
			}
		}
	}
my_pause
	setup_core  
my_pause
	setup_segment "Core: Virtex for Segment ADC card 1" 
my_pause
	setup_segment "Core: Virtex for Segment ADC card 2" 
my_pause
	setup_segment "Segment: Virtex for Segment ADC card 1" 
my_pause
	setup_segment "Segment: Virtex for Segment ADC card 2" 
my_pause
	setup_segment "Segment: Virtex for Segment ADC card 3" 
my_pause
	setup_segment "Segment: Virtex for Segment ADC card 4" 
my_pause
	InsertLog "Initialised Digitiser all channels transmitting ADC data"

	InsertLog "Script completed "
}

proc my_pause { } {
	global %%Waiting do_pause
	if { $do_pause ==0 } {
		return
		} else {
		WaitForUser "Continue  ?"
		set rtnd %%Waiting
		if { $rtnd == -2 } {
			InsertLog "Ended "
			return
		}
	}
}

proc setup_segment { board } {
	global %%Waiting
	set dg_status [click-status]
	InsertLog "Initialising $board"
	set rtnd 0

	if { [SelectFpga "$board"] == -1 } then { 
		WaitForUser "Segment card --- %board---- not available !" 
		return
	}
# set the basics - inspection and main enables
	setup_offset_seg
# enable the laser
	Set_Register 0 5
	Set_Register 4 7
	Set_Register 7 0xFF00

# check the status register for DCM locked.
	set val [Get_Register 1 ]
	if { $val != 0xe001 } {
		InsertLog "Segment status  fault : ([format "0x%x" $val])"
		WaitForUser "Continue  ?"
		set rtnd [ set %%Waiting ]
		if { $rtnd == -2 } {
			return
		}
	}
	set val 1
	Set_Register 2 $val
	Set_Register 3 $val
	Set_Register 8 $val
#	InsertLog "Inspection lines set for channel 1"
# channel by channel set inspection lines 1 and 2 and analog to ch, and transmit data enabled
	foreach val { 1 2 3 4 5 6 } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0x7c00
		set ch_rkt [expr ( $val << 4 ) + 4 ]
		Set_Register $ch_rkt 0
	}
	foreach val { 1 2 3 4 5 6 } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0
	}
	
	if { $rtnd == -2 } {
		InsertLog "Ended "
		return
	}
	InsertLog "Script completed for $board "
}

proc setup_core {} {
	global %%Waiting
	set dg_status [click-status]
	set rtnd 0

	if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
		WaitForUser "No Core card available !" 
		return
	}
# set the basics - inpsection and main enables
	InsertLog "Initialise Core Offsets and data link"
	setup_offset_core
# enable the laser
#	Set_Register 0 0x75
	Set_Register 4 7
	Set_Register 7 0x300

# check the status register for DCM locked.
	 set val [Get_Register 1 ]
	 set val [ expr $val & 0xfffD ]
	 if { $val != 0xf205 } {
		InsertLog "Core status error: ([format "0x%x" $val])"
		WaitForUser "Continue  ?"
		set rtnd [ set %%Waiting ]
		if { $rtnd == -2 } {
			return
		}
	}
	set val 1
#	Set_Register 2 $val
#	Set_Register 3 $val
#	Set_Register 8 $val
# channel by channel set inspection lines 1 and 2 and analog to ch, and transmit data enabled
	foreach val { 1 2  } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0x7c00
		set ch_rkt [expr ( $val << 4 ) + 4 ]
		Set_Register $ch_rkt 0
	}
	foreach val { 1 2  } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0
	}
}

proc setup_offset_core {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
}
proc setup_offset_seg {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
	Set_Register 0x83 0
	Set_Register 0x84 0
	Set_Register 0x85 0
	Set_Register 0x86 0
	Set_Register 0x87 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
