#Prom_read_basic.tcl
set Prom_control 0x880
set Prom_status 0x881
set Prom_base 0x800

proc run_test {} {
	global Prom_control Prom_status Prom_base  
	global %%Waiting

# check to see if it has read in correctly 
	set a 0
	while { $a != 4 } {
		set a [ Get_Register $Prom_status ]
		if { $a != 4 } {
			InsertLog "Prom has read back unsuccessfully. Status : $a"
			WaitForUser "Continue to Retry or Abort to end?"
			set rtnd [ set %%Waiting ]
			if { $rtnd == -2 } {
				return
			}
		Set_Register 0 0x1000		
		Set_Register 0 0		
		} 
	}
	InsertLog "Prom Read back into RAM"

	set a [ format "%c" [ Get_Register 0x800 ] ]
	
	if { $a == "C" } {
		InsertLog "This is a Core ADC board"
	} elseif { $a == "S" } {
		InsertLog "This is a Segment ADC board" 
	} else {
		InsertLog "Not sure what this is : [ format "%c" $a ] !"
	}
	set a [ Get_Register 0x801 ]
	set b [ Get_Register 0x802 ]
	set c [ Get_Register 0x803 ]
	set d [ Get_Register 0x804 ]
	set e [ Get_Register 0x805 ]
	set f [ Get_Register 0x806 ]
	set g [ Get_Register 0x807 ]
	set serial [ format "%c%c%c%c" $d $c $b $a ]
	set revision [ format "%c" $e ]
	set mod_state [ format "%c%c" $g $f ]

	InsertLog "Serial number : $serial"
	InsertLog "Revision      : $revision"
	InsertLog "Mod state     : $mod_state"
	InsertLog "Script Complete ....."

}
# finally do the work ;-)
run_test

# WaitForUser "Data enabled, is the  ?"
#    syntax  Set_Register address_offset  value
# WaitForUser "Data synchronised ?"
# InsertLog "wait returned [set %%Waiting]"
# values of %%Waiting are  -1 (continue)   and   -2  (Abort)
# InsertLog "register at offset 2 has value [Get_Register 2]"
#    syntax  Get_Register address_offset
#    returns value

# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 
