# Segment_laser_spares.tcl

proc run_test {} {
global %%Waiting
set dg_status [click-status]
InsertLog "Initialise Segment and test a register "

if { [SelectFpga "Core: Virtex for Segment ADC card 2"] == -1 } then { 
	WaitForUser "No Segment card available !" 
	return
}
# set the basics - inpsection and main enables
	setup_offset
# enable the laser and select the spares to run
	Set_Register 0 0x4005
	Set_Register 4 7
	Set_Register 7 0xFF00
# set the inspection line to monitors the 25Mhz
	Set_Register 10 0x0405 
# check the status register for DCM locked.
 set val [Get_Register 1 ]
 if { $val != 0xe001 } {
	InsertLog "Segment status  fault : ([format "0x%x" $val])"
	WaitForUser "Continue  ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}
}
# channel by channel set inspection lines 1 and 2 and analog to ch, and transmit data enabled
	Set_Register 0x93 0x7c00
	Set_Register 0x94 0
	Set_Register 0xA3 0x7c00
	Set_Register 0xA4 0
	InsertLog "Both spares : Transmitting sync pattern"
	WaitForUser "Check both data is FC00 & status is locked. OK?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		break
	}
	Set_Register 0x93 0
	Set_Register 0x94 1
	Set_Register 0xA3 0
	Set_Register 0xA4 1
	InsertLog "Segments Transmitting data : 0xF00D"
	WaitForUser "Check data Outputs OK?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		break
	}

if { $rtnd == -2 } {
	InsertLog "Ended "
	return
}
InsertLog "Script completed "
}

proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
	Set_Register 0x83 0
	Set_Register 0x84 0
	Set_Register 0x85 0
	Set_Register 0x86 0
	Set_Register 0x87 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
