# Segment_ram_cycle.tcl

proc run_test {} {
global %%Waiting
set dg_status [click-status]
InsertLog "Initialise Segment and cycle round ram test"

if { [SelectFpga "Core: Virtex for Segment ADC card 2"] == -1 } then { 
	WaitForUser "No Segment card available !" 
	return
}
# set the basics - inpsection and main enables
	setup_offset
# enable the laser
	Set_Register 0 5
	Set_Register 4 7
	Set_Register 7 0xFF00

# check the status register for DCM locked.
 set val [Get_Register 1 ]
 if { $val != 0xe001 } {
	InsertLog "Segment status  fault : ([format "0x%x" $val])"
	WaitForUser "Continue  ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		return
	}
  }
set val 1
while { $val == 1 }  {
	Set_Register 0 0x105
	WaitForUser "Continue  ?"
	set rtnd [ set %%Waiting ]
	if { $rtnd == -2 } {
		set val 0
	}
	Set_Register 0 0x5
}
InsertLog "Script completed "
}

proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
	Set_Register 0x83 0
	Set_Register 0x84 0
	Set_Register 0x85 0
	Set_Register 0x86 0
	Set_Register 0x87 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
