# Segment_ram_cycle.tcl

proc run_test {} {
global %%Waiting
set dg_status [click-status]
InsertLog "Run the Ram test"

if { [SelectFpga "Core: Virtex for Segment ADC card 2"] == -1 } then { 
	WaitForUser "No Segment card available !" 
	return
}

set val 1
set rtnd 0
Set_Register 0 0x5
Set_Register 0 0x105
InsertLog "Ram test started"
while { $val == 1 }  {
	set status [ Get_Register 1 ]
	set ram_result [ expr ( $status >> 4 ) & 7 ]
 	if { $ram_result != 1 } {
		InsertLog "Segment status RAM fault : ([format "0x%x" $status])"
		WaitForUser "Continue to read back and compare?"
		set rtnd [ set %%Waiting ]
		if { $rtnd == -2 } {
			set val 0
			return
		} else {
		set tracker 0
		set offset 1
		set myval 0X1001
		Set_Register 0 0x5
		set address 0x1000
			while { 1 } {
				set rval [ Get_Register $address ]
				if { $rval != $myval } {
					InsertLog "Addr: [format "0x%x" $address]; myval :[format "0x%x" $myval]; rval : [format "0x%x" $rval]"
					WaitForUser "Continue to read back and compare?"
					set rtnd [ set %%Waiting ]
					if { $rtnd == -2 } {
						return
					} 
				}
				set address [ expr $address + 1 ]
				if { $tracker != 0xFFFF } {
					set myval [ expr $myval + 1 ]
					set tracker [ expr $tracker + 1 ]
				} else {
					set offset [ expr $offset + 1 ]
					set myval $offset
					set tracker 0 
					InsertLog "Addr: [format "0x%x" $address]; myval :[format "0x%x" $myval]; offset : [format "0x%x" $offset]"
				}
			}
		}
	} else {
		set val 0
	}
}
if { $rtnd == -2 } {
	InsertLog "Ended "
	return
}
Set_Register 0 0x5
if { $ram_result == 1 } {
	InsertLog " RAM test passed "
} else {
	InsertLog " RAM test failed "
}
InsertLog "Script completed "
}

proc setup_offset {} {
	Set_Register 0x81 0
	Set_Register 0x82 0
	Set_Register 0x83 0
	Set_Register 0x84 0
	Set_Register 0x85 0
	Set_Register 0x86 0
	Set_Register 0x87 0
}
run_test
# InsertLog "register at offset 2 has value [Get_Register 2]"
# potential Fpgas are 
#       "Core: Virtex for Segment ADC card 1" 
#       "Core: Virtex for Segment ADC card 2" 
#       "Core: Virtex for core ADCs" 
#       "Core: Main Board" 
#       "Segment: Virtex for Segment ADC card 1" 
#       "Segment: Virtex for Segment ADC card 2" 
#       "Segment: Virtex for Segment ADC card 3" 
#       "Segment: Virtex for Segment ADC card 4" 
#       "Segment: Main Board" 

#    syntax  Set_Register address_offset  value
#    syntax  Get_Register address_offset
#    returns value
# WaitForUser "Data synchronised ?"

# InsertLog "wait returned [set %%Waiting]"

#values of %%Waiting are  -1 (continue)   and   -2  (Abort)
